/**
 * Proiect PM 2017
 * Jocul Doodle Jump
 * Mihalea Matei 331CC
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
//#include <time.h>
#include <avr/io.h>

#include "lcd.h"

#define F_CPU 16000000
#define TRUE 			1
#define FALSE			0

#define DELAY_MOVE		75

#define	VISIBLE			1
#define	INVISIBLE		0

/* Initializations */
//doar 1 proiectil(urmatorul cand iese din ecran / nimereste)
	
signed char platforms[100][4];


unsigned char monsters[20][4];
//platforms + enemies pot fi definiti toti de la inceput


typedef enum {UPWARDS, DOWNWARDS} player_state;

struct player {
	unsigned char player_x, player_y, model;
	player_state state;
};

unsigned char game_over, player_height;//inaltimea(punctajul e functie de inaltime) la care a ajung
unsigned char shot_x, shot_y, shot;//speed?
unsigned char nr_monsters, nr_platforms;
unsigned int score, max_score;
unsigned char shift_up, shift_right; // pentru jump

unsigned char start_jump_height;//inaltimea ultimei platforme de pe care a sarit
unsigned char current_jump_height;//inaltimea pe care o are saritura actuala
unsigned char jump_type;
struct player Player;

/* Functions */
void game_init()
{
	int i;
	Player.player_x = 7;
	Player.player_y = 6;
	Player.state = UPWARDS;
	Player.model = DOODLER1;
	
	nr_monsters = 20;
	nr_platforms = 100;
	
	srand(13);//
	for(i = 0; i < nr_platforms; i++){
		platforms[i][0] = (rand() % 12) + 1;
		platforms[i][1] = -(i - 5) - rand() % 2;
		platforms[i][2] = VISIBLE;
		platforms[i][3] = 1;// rand ???
	}
	
	for(i = 0; i < nr_monsters; i++){
		monsters[i][0] = (rand() % 12) + 1;
		monsters[i][1] = -(i * 5) - rand() % 2;
		monsters[i][2] = VISIBLE;
		monsters[i][3] = 1;// rand ???
	}

	
	shot_x = 0; shot_y = 0; shot = 0;
	game_over = 0;
	
	shift_up = 0;
	shift_right = 1;//1 == no shift
	start_jump_height = 0;
	current_jump_height = 0;
	
	score = 0;
	max_score = 0;
}

/* Move player through buttons */
void move_player() 
{

	/* Move left */
	if((PINA & (1 << PA7)) == 0){
		shift_right--;
	
		if(shift_right == 0){
			shift_right = 5;
			Player.player_x -= 1;
		}
		_delay_ms(DELAY_MOVE);
	}
		
	/* Move right */
	if((PINA & (1 << PA5)) == 0){
		shift_right++;
	
		if(shift_right >= 6){
			shift_right = 1;
			Player.player_x += 1;
		}
		_delay_ms(DELAY_MOVE);
	}
	
}

int test_hit()//enemies + shot collision 
{ 
	int i;
	
	for(i = 0; i < nr_monsters; i++)
		if(monsters[i][1] >= 1 && monsters[i][1] <= 6)
			if(shot_y == monsters[i][1]
			&& shot_x >= monsters[i][0] - 1 && shot_x <= monsters[i][0] + 1){//TODO: conditie shift
				monsters[i][2] = INVISIBLE;
				return i;
			}
			
	return -1;
}

void test_boom()//enemies + shot collision 
{ 
	int i;
	
	for(i = 0; i < nr_monsters; i++)
		if(monsters[i][1] >= 1 && monsters[i][1] <= 6 && monsters[i][2] == VISIBLE)
			if(Player.player_y >= (monsters[i][1] - 1) && Player.player_y <= (monsters[i][1] + 1)
			&& Player.player_x >= monsters[i][0] - 1 && Player.player_x <= monsters[i][0] + 2){//TODO: conditie shift
				game_over = 1;
			}
}

int test_jump()//when to jump(shift considered)
{
	int i;
	
	for(i = 0; i < nr_platforms; i++)
		if(platforms[i][1] >= 1 && platforms[i][1] <= 6)
			if(shift_up == 1 && Player.player_y == platforms[i][1] 
							&& Player.player_x >= platforms[i][0] - 1 && Player.player_x <= platforms[i][0] + 2)//TODO: conditie shift
				return i;
			
	return -1;
}

int test_col()//Player + platform collision
{
	int i;
	
	for(i = 0; i < nr_platforms; i++)
		if(platforms[i][1] >= 1 && platforms[i][1] <= 6)
			if(Player.player_y == platforms[i][1] 
							&& Player.player_x >= platforms[i][0] - 1 && Player.player_x <= platforms[i][0] + 2)//TODO: conditie shift
				return i;
			
	return -1;
}

void shoot()//diplay shot
{
	if(shot == 0 && (PINA & (1 << PA6)) == 0){
		shot_x = Player.player_x + 1;
		shot_y = Player.player_y;
		shot = 1;
	}
	else{
		//check collisions
		if(test_hit() != -1){
			shot = 0;
		}
			
		//display_shot
		if(shot == 1){
			if (shot_y > 1) {//conditie iesire ecran
				shot_y--;
				lcd_goto_xy(shot_x, shot_y);
				lcd_chr(SHOT);
			}
			else{
				PORTD ^= (1 << PD7);
				shot = 0;
			}
		}
	}
}

void jump()
{
	int i;
	
	if(Player.player_y >= 4) {
		shift_up++; current_jump_height++; score++;
		
		if(current_jump_height - start_jump_height > 20)
			Player.state = DOWNWARDS;
			
		if(shift_up >= 8){
			shift_up = 0;
			Player.player_y--;
		}
	}
	else {//coboara platforme
	
		for(i = 0; i < nr_platforms; i++){
			platforms[i][3]--;
		}
		for(i = 0; i < nr_monsters; i++){
			monsters[i][3]--;
		}
		current_jump_height++;
		
		if(current_jump_height - start_jump_height > 20){
			
			Player.state = DOWNWARDS;
			//PORTD ^= (1 << PD7);
		}
		
		if(platforms[0][3] == 0)
			for(i = 0; i < nr_platforms; i++){
				platforms[i][3] = 8;
				platforms[i][1]++;//_delay_ms(75);
			}
		if(monsters[0][3] == 0)
			for(i = 0; i < nr_monsters; i++){
				monsters[i][3] = 8;
				monsters[i][1]++;//_delay_ms(75);
			}
	}
	//retine inaltimea de la care a sarit + pe ce a sarit(platforma / putere speciala) + viteza
	//creste inaltimea la fiecare "update" 
	//nu creste neaparat coordinata y a jucatorului ci toate obiectele nivelului se misca in jos
	//cand a ajund la inaltimea maxima incepe sa coboare -> fall (Player.state = DOWNWARD)
}

void fall()
{
	if(shift_up != 0)
		shift_up--;
		
	if(shift_up == 0){
		shift_up = 8;
		Player.player_y++;
	}
	
	if(test_jump() != -1) {
		Player.state = UPWARDS;
		start_jump_height = 0;
		current_jump_height = 0;
	}
	
	if(Player.player_y > 7)
		game_over = 1;
}

void display_player()
{
	lcd_goto_xy(Player.player_x, Player.player_y);//ok
	lcd_mychr_up(DOODLER1, shift_up, shift_right);
	lcd_mychr_up(DOODLER2, shift_up, shift_right);
	
	lcd_goto_xy(Player.player_x, Player.player_y - 1);
	lcd_mychr_comp(DOODLER3, DOODLER1, shift_up, shift_right);//+ Doodler3
	lcd_mychr_comp(DOODLER4, DOODLER2, shift_up, shift_right);
	
	lcd_goto_xy(Player.player_x, Player.player_y - 2);//ok
	lcd_mychr_down(DOODLER3, 8 - shift_up, shift_right);
	lcd_mychr_down(DOODLER4, 8 - shift_up, shift_right);
}

void display_player_comp(int index)
{
	lcd_goto_xy(Player.player_x, Player.player_y);//ok
	lcd_mychr_comp2(DOODLER1, PLATFORM, shift_up, shift_right, platforms[index][3]); //shift_right = 1
	lcd_mychr_comp2(DOODLER2, PLATFORM, shift_up, shift_right, platforms[index][3]);
	
	lcd_goto_xy(Player.player_x, Player.player_y - 1);
	lcd_mychr_comp(DOODLER3, DOODLER1, shift_up, shift_right);//+ Doodler3
	lcd_mychr_comp(DOODLER4, DOODLER2, shift_up, shift_right);
	
	lcd_goto_xy(Player.player_x, Player.player_y - 2);//ok
	lcd_mychr_down(DOODLER3, 8 - shift_up, shift_right);
	lcd_mychr_down(DOODLER4, 8 - shift_up, shift_right);
}

void display_platforms()
{
	int i;
	
	for(i = 0; i < nr_platforms; i++)
		if(platforms[i][1] >= 1 && platforms[i][1] <= 6)
		{
			lcd_goto_xy(platforms[i][0] , platforms[i][1] );
			lcd_chr2(PLATFORM);
			lcd_chr2(PLATFORM);
			lcd_chr2(PLATFORM);
		}
}

void display_monsters()
{
	int i;
	
	for(i = 0; i < nr_monsters; i++)
		if(monsters[i][2] == VISIBLE && (monsters[i][1] >= 2 && monsters[i][1] <= 6))
		{
			
			lcd_goto_xy(monsters[i][0], monsters[i][1]);//ok
			lcd_chr(MONSTER1);
			lcd_chr(MONSTER2);
		
			lcd_goto_xy(monsters[i][0], monsters[i][1] - 1);
			lcd_chr(MONSTER3);
			lcd_chr(MONSTER4);
			
		}
}

/* Initializeaza intrarile si iesirile */
void IO_init() 
{
	DDRD |= (1 << PD7);
	
    // butoanele setate ca intrare
    DDRA |= (1 << PA7) | (1 << PA6) | (1 << PA5);
	
	// activare rezistente de pull-up
    PORTA |= (1 << PA7) | (1 << PA6) | (1 << PA5);
}

int main(void)
{
	/* I/O Initialization */
	sei();
	IO_init();
	
	/* LCD Initialization */
	lcd_init();
	lcd_contrast(0x40);
	
	/* Game Initialization */
	game_init();
	
	/* Start screen */
	/* Start screen */
	while(1) {
		
		lcd_goto_xy(3,2);
		lcd_str("DOODLE JUMP");
		
		lcd_goto_xy(6,4);
		lcd_str("START");
		
		if ((PINA & (1 << PA5)) == 0) {//start game button(mid)
			break;
		}
		_delay_ms(50);
	}
	
	while(game_over == 0){
		//TODO: play
		move_player();
		
		//lcd_chr with 2 argument(nr de pixeli + caracterul)
		//doar vertical -> lungime vector = 1 + width??
		
		
		/* Afisare player si obiecte din nivel */
		lcd_clear();
		
		/* Verify player state */
		switch(Player.state) {
			case UPWARDS:
				jump();
				break;
						
			case DOWNWARDS:
				fall();
				break;
		}
		
		
		display_platforms();
		
		display_monsters();
		
		int res = test_col();
		if(res == -1)
			display_player();
		else{
			display_player_comp(res);
		}
		
		shoot();
        test_boom();
		
		
		lcd_goto_xy(1, 1);
		char str_score[15];
		sprintf(str_score, "%d", score);
		lcd_str(str_score);
		
		_delay_ms(50);
	}
	
	/* Game Over */
	lcd_clear();
	
	lcd_goto_xy(2,1);
	lcd_str("GAME OVER!!!");
	
	lcd_goto_xy(1,3);
	char str_score[15];
	sprintf(str_score, "%d", score);
	lcd_str("YOUR SCORE: "); //TODO: score
	lcd_str(str_score);
	/* Save max score */
	if(score > max_score)
		max_score = score;
		

	lcd_goto_xy(1,5);
	sprintf(str_score, "%d", max_score);
	lcd_str("MAX SCORE: "); //TODO: score
	lcd_str(str_score);
	
	return 0;
	
}