/*
** lcd.h
**
** LCD 3310 driver
** Target: ATMEGA :: AVR-GCC
**
** Written by Tony Myatt - 2007
** Quantum Torque - www.quantumtorque.com
*/
#ifndef _NOKIALCD_H_
#define _NOKIALCD_H_

/* Lcd screen size */
#define LCD_X_RES 84
#define LCD_Y_RES 48
//#define BYTE_SIZE 8
//#define UNDEFINED -1
#define LCD_CACHE_SIZE ((LCD_X_RES * LCD_Y_RES) / 8)

/* Pinout for LCD */
#define LCD_CLK_PIN 	(1<<PC6)
#define LCD_DATA_PIN 	(1<<PC5)
#define LCD_DC_PIN 		(1<<PC4)
#define LCD_CE_PIN 		(1<<PC3)
#define LCD_RST_PIN 	(1<<PC2)
#define LCD_PORT		PORTC
#define LCD_DDR			DDRC

/* Special Chars */
#define DOODLER1 ICON(0)
#define DOODLER2 ICON(1)
#define DOODLER3 ICON(2)
#define DOODLER4 ICON(3)
#define PLATFORM ICON(4)
#define MONSTER1 ICON(5)
#define MONSTER2 ICON(6)
#define MONSTER3 ICON(7)
#define MONSTER4 ICON(8)
#define SHOT	 ICON(9)
//TODO: add characters / enemiess / obstacle / platforms

/* Function for my special characters */
#define	ICON(x)		'm'+1+x

void lcd_init(void);
void lcd_contrast(unsigned char contrast);
void lcd_clear(void);
void lcd_clear_area(unsigned char line, unsigned char startX, unsigned char endX);
void lcd_fill_area(unsigned char line, unsigned char startX, unsigned char endX);
void lcd_clear_line(unsigned char line);
void lcd_fill_line(unsigned char line);
void lcd_goto_xy(unsigned char x, unsigned char y);
void lcd_goto_xy_exact(unsigned char x, unsigned char y);
void lcd_chr(char chr);
void lcd_chr2(char chr);
void lcd_mychr_up(char chr, unsigned char shift_up, unsigned char shift_right);
void lcd_mychr_down(char chr, unsigned char shift_up, unsigned char shift_right);
void lcd_mychr_comp(char chr1, char chr2, unsigned char shift_up, unsigned char shift_right);
void lcd_mychr_comp2(char chr1, char chr2, unsigned char shift_up1, unsigned char shift_right, unsigned char shift_up2);
void lcd_str(char* str);
//other functions(2)

/* Custom functions */
//TODO: add custom functions

#endif